summaryrefslogtreecommitdiff
path: root/test/TEST-14-IMSM
diff options
context:
space:
mode:
authorHarald Hoyer <harald@redhat.com>2009-09-08 13:43:21 +0200
committerHarald Hoyer <harald@redhat.com>2009-09-08 13:43:21 +0200
commit0e9bb3f30c4de4e67ce03b6787770b7ff98cffec (patch)
treecb1e283b173a7fc7d8c28f1b66da78859e3f5894 /test/TEST-14-IMSM
parent3bb5b261c778a82ace8a16578a5b8cb3af71618b (diff)
downloaddracut-0e9bb3f30c4de4e67ce03b6787770b7ff98cffec.tar.gz
dracut-0e9bb3f30c4de4e67ce03b6787770b7ff98cffec.tar.bz2
dracut-0e9bb3f30c4de4e67ce03b6787770b7ff98cffec.zip
TEST-14-IMSM: no test for a isw raid array
Diffstat (limited to 'test/TEST-14-IMSM')
-rw-r--r--test/TEST-14-IMSM/Makefile10
-rwxr-xr-xtest/TEST-14-IMSM/create-root.sh36
-rwxr-xr-xtest/TEST-14-IMSM/cryptroot-ask6
-rwxr-xr-xtest/TEST-14-IMSM/hard-off.sh2
-rwxr-xr-xtest/TEST-14-IMSM/test-init11
-rwxr-xr-xtest/TEST-14-IMSM/test.sh98
6 files changed, 163 insertions, 0 deletions
diff --git a/test/TEST-14-IMSM/Makefile b/test/TEST-14-IMSM/Makefile
new file mode 100644
index 00000000..bc0ddb61
--- /dev/null
+++ b/test/TEST-14-IMSM/Makefile
@@ -0,0 +1,10 @@
+all:
+ @make -s --no-print-directory -C ../.. all
+ @basedir=../.. testdir=../ ./test.sh --all
+setup:
+ @make --no-print-directory -C ../.. all
+ @basedir=../.. testdir=../ ./test.sh --setup
+clean:
+ @basedir=../.. testdir=../ ./test.sh --clean
+run:
+ @basedir=../.. testdir=../ ./test.sh --run
diff --git a/test/TEST-14-IMSM/create-root.sh b/test/TEST-14-IMSM/create-root.sh
new file mode 100755
index 00000000..5a15cb2a
--- /dev/null
+++ b/test/TEST-14-IMSM/create-root.sh
@@ -0,0 +1,36 @@
+#!/bin/sh
+# don't let udev and this script step on eachother's toes
+for x in 61-dmraid-imsm.rules 65-md-incremental-imsm.rules 65-md-incremental.rules 64-lvm.rules 70-mdadm.rules 99-mount-rules; do
+ > "/etc/udev/rules.d/$x"
+done
+udevadm control --reload-rules
+echo y|dmraid -f isw -C Test0 --type 1 --disk "/dev/sdb /dev/sdc"
+udevadm settle
+dmraid -a y
+# save a partition at the beginning for future flagging purposes
+sfdisk -H 255 -S 63 -L /dev/mapper/isw*Test0 <<EOF
+,1
+,1
+,1
+,
+EOF
+udevadm settle
+dmraid -a n
+udevadm settle
+dmraid -a y
+udevadm settle
+sfdisk -l /dev/mapper/isw*Test0
+for i in /dev/mapper/isw*p[123]; do
+lvm pvcreate -ff -y $i ;
+done && \
+lvm vgcreate dracut /dev/mapper/isw*p[123] && \
+lvm lvcreate -l 100%FREE -n root dracut && \
+lvm vgchange -ay && \
+mke2fs -L root /dev/dracut/root && \
+mkdir -p /sysroot && \
+mount /dev/dracut/root /sysroot && \
+cp -a -t /sysroot /source/* && \
+umount /sysroot && \
+lvm lvchange -a n /dev/dracut/root && \
+echo "dracut-root-block-created" >/dev/sda
+poweroff -f
diff --git a/test/TEST-14-IMSM/cryptroot-ask b/test/TEST-14-IMSM/cryptroot-ask
new file mode 100755
index 00000000..db27c5b8
--- /dev/null
+++ b/test/TEST-14-IMSM/cryptroot-ask
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+[ -b /dev/mapper/$2 ] && exit 0
+echo -n test >/keyfile
+/sbin/cryptsetup luksOpen $1 $2 </keyfile
+
diff --git a/test/TEST-14-IMSM/hard-off.sh b/test/TEST-14-IMSM/hard-off.sh
new file mode 100755
index 00000000..85fd8497
--- /dev/null
+++ b/test/TEST-14-IMSM/hard-off.sh
@@ -0,0 +1,2 @@
+#!/bin/sh
+getarg rdinitdebug || poweroff -f
diff --git a/test/TEST-14-IMSM/test-init b/test/TEST-14-IMSM/test-init
new file mode 100755
index 00000000..0a8618fc
--- /dev/null
+++ b/test/TEST-14-IMSM/test-init
@@ -0,0 +1,11 @@
+#!/bin/sh
+exec >/dev/console 2>&1
+echo "dracut-root-block-success" >/dev/sda
+export TERM=linux
+export PS1='initramfs-test:\w\$ '
+cat /proc/mdstat
+[ -f /etc/fstab ] || ln -s /proc/mounts /etc/fstab
+stty sane
+echo "made it to the rootfs! Powering down."
+mount -n -o remount,ro /
+poweroff -f
diff --git a/test/TEST-14-IMSM/test.sh b/test/TEST-14-IMSM/test.sh
new file mode 100755
index 00000000..3fe934ec
--- /dev/null
+++ b/test/TEST-14-IMSM/test.sh
@@ -0,0 +1,98 @@
+#!/bin/bash
+TEST_DESCRIPTION="root filesystem on LVM PV on a isw dmraid"
+
+KVERSION=${KVERSION-$(uname -r)}
+
+# Uncomment this to debug failures
+#DEBUGFAIL="rdinitdebug rdnetdebug"
+
+
+client_run() {
+ echo "CLIENT TEST START: $@"
+ $testdir/run-qemu -hda root.ext2 -hdb disk1 -hdc disk2 -m 256M -nographic \
+ -net none -kernel /boot/vmlinuz-$KVERSION \
+ -append "$@ root=LABEL=root rw quiet rdinfo console=ttyS0,115200n81 rdshell $DEBUGFAIL" \
+ -initrd initramfs.testing
+ if ! grep -m 1 -q dracut-root-block-success root.ext2; then
+ echo "CLIENT TEST END: $@ [FAIL]"
+ return 1;
+ fi
+
+ sed -i -e 's#dracut-root-block-success#dracut-root-block-xxxxxxx#' root.ext2
+ echo "CLIENT TEST END: $@ [OK]"
+ return 0
+}
+
+test_run() {
+ client_run || return 1
+ client_run rd_NO_MDIMSM || return 1
+ client_run rd_NO_MD rd_NO_MDIMSM || return 1
+ client_run rd_NO_DM || return 1
+# FIXME:
+# client_run rd_NO_DM rd_NO_MDIMSM && return 1
+# client_run rd_NO_MD && return 1
+}
+
+test_setup() {
+ # Create the blank file to use as a root filesystem
+ dd if=/dev/zero of=root.ext2 bs=1M count=1
+ dd if=/dev/zero of=disk1 bs=1M count=40
+ dd if=/dev/zero of=disk2 bs=1M count=40
+
+ kernel=$KVERSION
+ # Create what will eventually be our root filesystem onto an overlay
+ (
+ initdir=overlay/source
+ . $basedir/dracut-functions
+ dracut_install sh df free ls shutdown poweroff stty cat ps ln ip route \
+ /lib/terminfo/l/linux mount dmesg ifconfig dhclient mkdir cp ping dhclient
+ inst "$basedir/modules.d/40network/dhclient-script" "/sbin/dhclient-script"
+ inst "$basedir/modules.d/40network/ifup" "/sbin/ifup"
+ dracut_install grep
+ inst ./test-init /sbin/init
+ find_binary plymouth >/dev/null && dracut_install plymouth
+ (cd "$initdir"; mkdir -p dev sys proc etc var/run tmp )
+ )
+
+ # second, install the files needed to make the root filesystem
+ (
+ initdir=overlay
+ . $basedir/dracut-functions
+ dracut_install sfdisk mke2fs poweroff cp umount strace fdisk
+ inst_simple ./create-root.sh /initqueue/01create-root.sh
+ )
+
+ # create an initramfs that will create the target root filesystem.
+ # We do it this way so that we do not risk trashing the host mdraid
+ # devices, volume groups, encrypted partitions, etc.
+ $basedir/dracut -l -i overlay / \
+ -m "dash lvm mdraid dmraid udev-rules base rootfs-block kernel-modules" \
+ -d "ata_piix ext2 sd_mod dm-multipath dm-crypt dm-round-robin faulty linear multipath raid0 raid10 raid1 raid456" \
+ -f initramfs.makeroot $KVERSION || return 1
+ rm -rf overlay
+ # Invoke KVM and/or QEMU to actually create the target filesystem.
+ $testdir/run-qemu -hda root.ext2 -hdb disk1 -hdc disk2 -m 256M -nographic -net none \
+ -kernel "/boot/vmlinuz-$kernel" \
+ -append "root=/dev/dracut/root rw rootfstype=ext2 quiet console=ttyS0,115200n81" \
+ -initrd initramfs.makeroot || return 1
+ grep -m 1 -q dracut-root-block-created root.ext2 || return 1
+ (
+ initdir=overlay
+ . $basedir/dracut-functions
+ dracut_install poweroff shutdown
+ inst_simple ./hard-off.sh /emergency/01hard-off.sh
+ )
+ sudo $basedir/dracut -l -i overlay / \
+ -o "plymouth" \
+ -a "debug" \
+ -d "ata_piix ext2 sd_mod" \
+ -f initramfs.testing $KVERSION || return 1
+}
+
+test_cleanup() {
+ rm -fr overlay mnt
+ rm -f root.ext2 initramfs.makeroot initramfs.testing
+ rm -f disk1 disk2
+}
+
+. $testdir/test-functions